\documentclass[a4paper,12pt,oneside]{scrreprt}
\usepackage[latin1]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{ae,aecompl}
\usepackage[english]{babel}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{wrapfig}
\usepackage{ulem}
\usepackage{cancel}
\usepackage{float}
\usepackage{color}
\usepackage{titlesec}
\usepackage{geometry}
\usepackage{listings}
\geometry{verbose,a4paper,tmargin=25mm,bmargin=25mm,lmargin=15mm,rmargin=25mm}
\titlelabel{\thetitle.\quad}
\usepackage{tabularx}
\usepackage{booktabs}
\usepackage{pdfpages}
\usepackage{paralist}
\usepackage{textcomp}
\usepackage[official]{eurosym}

\usepackage{hyperref}
\hypersetup{
    colorlinks=true,
    linkcolor=blue,
    filecolor=magenta,      
    urlcolor=cyan,
}

\renewcommand{\rmdefault}{phv}
\renewcommand{\sfdefault}{phv}

\begin{document}
    \begin{tabular*}{\textwidth}{c @{\extracolsep{\fill}} cc}
        \begin{large}
            \textbf{Prof. Lichter}
        \end{large} &

        \begin{minipage}[H]{3.5cm}
            \centering
            \begin{large}
                OOSC
            \end{large} \\
            \begin{large}
                WS 2019/2020
            \end{large}
        \end{minipage} &

        \begin{minipage}[H]{4cm}
            \includegraphics[keepaspectratio,width=\textwidth,angle=0]{logoswc.png}
        \end{minipage} \\
        Andreas Steffens & & \\
        Konrad F\"ogen & &  \\
        & \begin{huge}
              \textbf{Submission 4}
        \end{huge}&  \\
        & oosc@swc.rwth-aachen.de &  \\
        & & \\
        % Hier drunter mÃ¼ssen die Daten noch angepasst werden
        Issued: 02.12.2019 &
        Submission: 16.12.2019 &
        Discussion: 19.12.2019 \\
    \end{tabular*}
    \newline \newline \newline
    \begin{center}
        Submitted by 07

        \begin{tabular}{ll}
            Radu-Andrei Coanda, 344664. \\
            Clemens Frohnhofer, 333800\\
            Silas G\"unther, 382506  \\
            Christoph Kr\"amer, 318424  \\
        \end{tabular}
        \newline
        \\
        https://git.rwth-aachen.de/radu.coanda/19ws-oosc
    \end{center}

    \setcounter{chapter}{4} % Aktuelles Assigment
    \section{Assignment: Domain Modeling \& Use Cases}
        \textbf{Identify domain concepts}
        \begin{enumerate}
            \item [a)]
            \textbf{First we extract a list of all nouns:} \\
            furniture, floorplan, tool, interior design, students, amateurs, layout, flat, placement, old houses, appearance, room, wall, door, window, drawing, background image, catalogue, table, chair, bed, bathtub, plant, element, modification, movement, size, group, creation, extension, computation, space, amount, free space, rules, constraints, social feature, compatibility, file, web-based service, moderator, illegal content, platform, comment, project, user
            \\ \\
            \textbf{From this list we can remove the following irrelevant nouns:} \\
            tool, amateurs, old houses, computation, social feature, compatibility, flat, amount, illegal content, creation
            \\ \\
            \textbf{The following nouns are instances of concepts:} 
                \begin{center}
                    \begin{tabular}{|c | c|} 
                        \hline
                         concept & instances \\ [0.5ex] 
                        \hline
                        furniture & table, chair, bed, bathtub, plant \\
                        element & room, wall, door, window \\
                        user & moderator, student \\
                        modification & placement, movement, size, group\\
                         \hline
                    \end{tabular}
                \end{center}
                        
       
            \textbf{The following nouns are synonyms:}
                \begin{enumerate}
                    \item[-] drawing, background image 
                    \item[-] layout, floorplan, interior design, appearance
                    \item[-] rules, constraints
                    \item[-] file, project
                \end{enumerate}
       
            \textbf{The following are properties of other nouns:}
                \begin{center}
                    \begin{tabular}{|c | c|} 
                        \hline
                         noun & properties \\ [0.5ex] 
                        \hline
                        element & size, placement, group\\
                        
                         \hline
                    \end{tabular}
                \end{center}
      
            \textbf{The following are nouns that name services:} \\
            web-based service
            \\ \\
            \textbf{The following are nouns representing a relation between relevant nouns:} \\
                            \begin{center}
                    \begin{tabular}{|c | c | c|} 
                        \hline
                         ... is a relation & between ... & and ... \\ [0.5ex] 
                        \hline
                        modification & element & size, placement, group \\
                        constraint & element & element \\
                        modification & furniture & size, placement, group \\
                        constraint & furniture & element \\
                        extension & catalogue & furniture\\
                        
                         \hline
                    \end{tabular}
                \end{center}
           
            \textbf{The following are the remaining nouns:} \\
                            layout,
                            background image,
                            catalogue,
                            space,
                            element,
                            furniture,
                            platform,
                            comment,
                            project,
                            user
        \end{enumerate}
    
        \textbf{Domain Driven Design}
        \begin{enumerate}
            \item [b)]
                The following graphic represents the core domain of the application, because the main purpose of the app is to model a layout of a flat with possible building elements (windows, doors, ...) as well as with the furniture and to assure, that the model is valid (no overlapping of furniture/elements). All the other parts like importing/exporting files, the graphical representation or the web forum are only supporting this purpose. \\ 
                \includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex4Task_b_core.png}
            \item [c)]
                As described above the following three subdomains exist. The web forum is a generic subdomain, as there are very likely standard solutions available. The graphical representation and the import/export on the other hand are supporting subdomains, because they are tightly coupled to the concepts of the core domain. \\
                \includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex4Task_c_graphic.png}
                \includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex4Task_c_import.png}
                \includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex4Task_c_forum.png}
            \item [d)]
                The following graphic shows the relationships between the contexts. Between the core domain and the graphic representation there exists an Anti-Corruption-Layer on the core domain side. So the core domain is secure against changes in the published language of the graphic domain. To make the use of the graphic domain simple, the PL is combined with an OHS. The same relation can be found between the core domain and the Import/Export. \\
                Also the webForum has a relation to the import/export domain as well as to the core domain, because as it is possible to upload a project directly out of the application or import it as a file. Therefore on the webForum side, there is again a ACL and on the core domain and import/export side, there are again OHS mappings. \\
                \includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex4Task_d.png}
        \end{enumerate}
    
        \textbf{UML Domain Model}
        \begin{enumerate}
            \item [e)] \leavevmode \newline
             \includegraphics[keepaspectratio,width=\textwidth,angle=0]{Ex4Task_e_class_diagram.png}
        \end{enumerate}
    
        \textbf{DDD vs. OO Domain Model}
        \begin{enumerate}
            \item [f)] In the beginning it was a bit hard to extract the domain concepts out of the textual description, because this was a new method and using it felt quite unfamiliar. Also coming from a OO background one had to be careful not directly thinking in terms of classes, inheritance, relations, objects, but rather concentrate to filter out concepts and their relation to each other. Identifying the different domains on the other side was not a problem. \\
            Deriving the domain model in OO in the second step was much easier with the domain model at hand. It gave a good overview of all the necessary concepts and which of them are related to each other. Thus one could not overlook any concept and also it made it easy to have the complete picture in mind while developing.  
            \item [g)] Using DDD and OO together for modelling the domain has quiet a few benefits. Many concepts of DDD and OO have the same intent and therefore ideas developed with DDD can be easily translated to code using OO. For example the context mappings of DDD can be realised using patterns of OO. Another similarity would be the focus on the core domain, which translates to the business logic in OO. Moreover a benefit of using DDD is, that in the end there exists a ubiquitous language also used in the code, thus everyone involved in the project has a common language for discussion and therefore communication problems are reduced.
        \end{enumerate}
    
        \subsection*{Use Case Modelling}

        \paragraph*{h)} We've identified the following Use Cases for the Scenario that a new user plans to layout a new appartment:
        
        \includegraphics[keepaspectratio,width=\textwidth,angle=0]{use_cases_apt_layout_system.png}

        \paragraph*{i)}
        In the following are the tabular use cases:
        \includepdf[page=-]{tabular_use_cases}
        \paragraph*{j)}
        \includegraphics[keepaspectratio,width=\textwidth,angle=0]{uc_add_new_layout.png}
        
        \includegraphics[keepaspectratio,width=\textwidth,angle=0]{uc_comment.png}

        \includegraphics[keepaspectratio,width=\textwidth,angle=0]{uc_compute_free_space.png}

        \includegraphics[keepaspectratio,width=\textwidth,angle=0]{uc_publish_project.png}
        
        \includegraphics[keepaspectratio,width=\textwidth,angle=0]{uc_export_project.png}

        \paragraph*{k)} The advantages to model with activity diagrams are the follwing:
        \begin{itemize}
            \item \textbf{The formal model can be easily checked.} This adv. comes from the fact
            that we can "run" the model and the final system side-by-side and check if the desired behaviour happends.
            \item \textbf{Errors can be better recognized.} This. adv. comes from the fact, that
            we trace the flow of data and activities from the actors trough the system. Now if we notice at a point, 
            that something should have happended we can pin point the problem more exactly.
        \end{itemize}
        

\end{document}
